<template>
  <q-page class="q-px-md q-mt-md">
    <div class="row justify-center">
      <div class="col-12" style="max-width: 800px;">
        <q-card class="q-mb-md"
        >
          <q-card-section>
            <div class="text-h6">{{ this.edit == true ? "แก้ไข" : "เพิ่ม" }} Group</div>
          </q-card-section>
        </q-card>
      </div>
    </div>
    <div class="row justify-center">
      <div class="col-12" style="max-width: 800px;">
        <q-card style="max-width: 800px; margin: 0 auto;">
          <q-form
            ref="form"
            label-width="120px"
            @submit.prevent="Update"
          >
            <q-card-section>
              <div class="q-pa-md">
                <div class="row  q-my-md">
                  <div class="col-2 text-subtitle2 text-grey">
                    Code
                  </div>
                  <div class="col-10">
                    <q-input dense
                             v-model="$v.form.code.$model"
                             :error="$v.form.code.$error"
                             error-message="กรุณากรอก Code"
                             autocomplete="off"/>
                  </div>
                  <div class="col-2 text-subtitle2 text-grey">
                    Name
                  </div>
                  <div class="col-10">
                    <q-input dense
                             v-model="$v.form.name.$model"
                             :error="$v.form.name.$error"
                             error-message="กรุณากรอก Name"
                             autocomplete="off">
                    </q-input>
                  </div>
                </div>
                <div class="row items-center">
                  <div class="col-2 text-subtitle2 text-grey">
                    Name
                  </div>
                  <div class="col-10">
                  <q-select
                    filled
                    error-message="กรุณาเลือก Owner"
                    v-model="$v.form.member_created_id.$model"
                    :options="memberOptions"
                    use-input
                    hide-selected
                    fill-input
                    @filter="filterOptions"
                    input-debounce="0"
                    emit-value
                    map-options
                    :option-value="'id'"
                    :option-label="opt => `${opt.name} - ${opt.user}`"
                  >
                  </q-select>
                  </div>
                </div>
                <div class="row items-center ">
                  <div class="col-2 col-md-2 text-subtitle2 text-grey">
                    Status
                  </div>
                  <div class="col-4 col-md-4">
                    <q-toggle v-model="form.status" left-label :false-value="0" :true-value="1"/>
                  </div>
                  <div class="col-2 col-md-2 text-subtitle2 text-grey  ">
                    Display
                  </div>
                  <div class="col-4 col-md-4 ">
                    <q-toggle v-model="form.is_display" left-label :false-value="0" :true-value="1"/>
                  </div>
                </div>
                <div>
                  <q-separator inset class="q-my-lg"/>
                  <p v-if="$v.form.image.$error" class="text-negative text-center">* กรุณาอัพโหลดรูป</p>
                </div>
                <div class="row items-start q-gutter-md q-mt-lg">
                  <div class="col  text-subtitle2 text-grey">
                    <q-card>
                      <q-card-section>
                        <q-btn push color="white" text-color="primary" label="รูปปัจจุบัน">
                        </q-btn>
                        <q-img
                          :src="form.image"

                        >
                          <template v-slot:error>
                            <div class="absolute-full flex flex-center bg-negative text-white">
                              Cannot load image
                            </div>
                          </template>
                        </q-img>
                      </q-card-section>
                    </q-card>
                  </div>
                  <div class="col">
                    <q-uploader
                      label="รูปภาพเท่านั้นไม่เกิน 10MB"

                      bordered
                      @added="upload"

                    >
                      <template v-slot:header="scope">
                        <div class="row no-wrap items-center q-pa-sm q-gutter-xs">
                          <q-btn v-if="scope.queuedFiles.length > 0" icon="clear_all" @click="scope.removeQueuedFiles"
                                 round
                                 dense flat>
                            <q-tooltip>Clear All</q-tooltip>
                          </q-btn>
                          <div class="col">
                            <div class="q-uploader__title">{{ scope.label }}</div>
                          </div>
                          <q-btn v-if="scope.uploadedFiles.length > 0" icon="done_all"
                                 @click="scope.removeUploadedFiles"
                                 round dense flat>
                            <q-tooltip>Remove Uploaded Files</q-tooltip>
                          </q-btn>
                          <q-spinner v-if="scope.isUploading" class="q-uploader__spinner"/>

                          <q-btn v-if="scope.canAddFiles" type="a" icon="add_box" round dense flat>
                            <q-uploader-add-trigger/>
                            <q-tooltip>Pick Files</q-tooltip>
                          </q-btn>
                          <q-btn v-if="scope.isUploading" icon="clear" @click="scope.abort" round dense flat>
                            <q-tooltip>Abort Upload</q-tooltip>
                          </q-btn>
                        </div>
                      </template>
                    </q-uploader>
                  </div>
                </div>
              </div>
            </q-card-section>
            <q-card-actions align="right" class="bg-primary text-white">
              <q-btn
                push
                rounded
                color="primary"
                type="submit"
                v-show="permissions('change')"
              >Submit
              </q-btn>
              <q-btn push rounded color="primary" to="/v2/group">Cancel</q-btn>
            </q-card-actions>
          </q-form>
        </q-card>
      </div>
    </div>
  </q-page>
</template>
<script>
import {mapState, mapGetters, mapActions} from "vuex"
import {required} from 'vuelidate/lib/validators'

export default {
  name: "Group",
  data() {
    return {
      defaultForm: {name: "", code: "", image: null, status: 1, is_display: 1, member_created_id: undefined},
      form: {},
      edit: false,
      oldImage: undefined,
      newImage: undefined,
      permissions: () => false,
      preventByAdded: false,
      members: [],
      memberOptions: [],
    };
  },
  validations: {
    form: {
      name: {
        required
      },
      code: {
        required
      },
      image: {
        required
      },
      member_created_id: {
        required
      }
    }
  },
  computed: {
    id() {
      return this.$route.params.id;
    }
  },
  watch: {
    async id() {
      await this.load();
    }
  },
  async created() {
    this.permissions = await this.initPermission('group');
    if (this.$route.meta.edit) {
      await this.load();
    } else {
      this.form = Object.assign({}, this.defaultForm);
    }
    const { data } = await this.load_member({role_level: 2});
    this.members = data;
    this.memberOptions = data;
    this.edit = this.$route.meta.edit;
  },
  methods: {
    ...mapActions('permission', {
      initPermission: 'permission'
    }),
    ...mapActions('member', {
      load_member: 'load',
    }),
    ...mapActions('group/v2', {
      load_group_by_id: 'load',
      update_group: 'update',
      add_group: 'add'
    }),
    async load() {
      if (this.id) {
        this.edit = true;
        try {
          const {data} = await this.load_group_by_id(this.id);
          this.form = data;
        } catch (ex) {
          this.form = Object.assign({}, this.defaultForm);
          this.$dialog.errorException(ex);
        }
      } else {
        this.edit = false;
      }
    },
    async Update() {
      this.$q.loading.show();
      this.$v.form.$touch();
      try {
        if (!this.$v.form.$invalid) {
          let response;
          let data = Object.assign({}, this.form);
          if (this.newImage) {
            data.image = this.newImage;
          }
          if (data.image.startsWith('data:image')) {
            data.image = data.image.split(',')[1];
          }
          if (this.edit == false) {
            response = await this.add_group(data);
          } else {
            response = await this.update_group({
              id: this.id,
              data: data
            });
          }
          if (response.data) {
            this.$q.loading.hide();
            if (this.edit) {
              this.$dialog.alert("Alert", "Update Group Success")
                .onOk(() => {
                  this.$q.loading.show();
                  this.load().then(() => {
                    this.$q.loading.hide();
                  });
                });
            } else {
              this.$dialog.alert("Alert", "Add Group Success")
                .onOk(() => {
                  this.preventByAdded = true;
                  this.$router.replace({path: `/v2/group/${response.data.id}`});
                });
            }
          }
        } else {
          this.$q.loading.hide();
        }
      } catch (ex) {
        this.$q.loading.hide();
        this.$dialog.errorException(ex);
      }
    },
    upload(e) {
      const image = e[0];
      const reader = new FileReader();
      reader.onload = (e) => {
        this.oldImage = new String(this.form.image);
        this.newImage = reader.result;
        if (this.edit == false) {
          this.form.image = this.newImage;
        }
      };
      reader.readAsDataURL(image);
    },
    filterOptions(val, update, abort) {
      update(() => {
        const needle = val.toLowerCase();
        if (needle) {
          this.memberOptions = this.members.filter(v => `${v.name} - ${v.user}`.toLowerCase().indexOf(needle) > -1)
        } else {
          this.memberOptions = this.members;
        }
      })
    }
  },
  beforeRouteLeave(to, from, next) {
    if (this.preventByAdded) {
      next()
    } else {
      const answer = window.confirm('Do you really want to leave? you have unsaved changes!')
      if (answer) {
        next()
      } else {
        next(false)
      }
    }
  }
};
</script>
<style lang="scss" scoped>
img {
  border: 0.5px solid #ddd;
  max-height: 200px;
}

</style>
